/*
 * Respostas:
 * 
 * 1 - Não é possível criar um setter, pois o atributo é final, e assim não pode ser modificado depois de ser
 *  inicializado.
 *  
 * 2 - Sim. O modificador final faz com que não seja possível atribuir outros valores para uma variável. Se a variável
 *  é um valor primitivo, como um inteiro inicializado com 0, não podemos modificar seu valor para 2, depois. Se a
 *  variável é um objeto, então depois de inicializado ele aponta para um determinado endereço onde o objeto está.
 *  Essa referência ao objeto não pode ser modificada. Mas o objeto em si pode! Então não há problema em modificar
 *  um objeto final, portanto que a referência da variável não seja modificada.
 *  
 * 3 - Não fez efeito pelo mesmo motivo dado na resposta anterior. Podemos mudar o conteúdo do array, portanto
 *  que a referência não seja reatribuída.
 *  
 * 4 - Arraylist é tão eficiente quanto array, então não acredito que há muitas vantagens no uso de array. Quanto as
 *  vantagens de arraylist, não é necessário guardar a ocupacao atual, não é necessário saber onde adicionar, é mais
 *  fácil remover sem deixar espaços vazios, entre outros.
 */

package inicio;

import carona.Carona;
import carona.CaronaAL;
import caronante.Caronante;
import caroneiro.Caroneiro;
import perfil.Perfil;
import usuario.Usuario;

public class Lab3 {

	public static void main(String[] args) {
		Caronante caronante = new Caronante(5, "Chamber pop", "abcd-123", "abdef12345",
				"Alguma marca", "Algum modelo", 3);
		Caroneiro caroneiro1 = new Caroneiro(true);
		Caroneiro caroneiro2 = new Caroneiro(false);
		Caroneiro caroneiro3 = new Caroneiro("5435345345");
		Caroneiro caroneiro4 = new Caroneiro("1233435454");
		
		Carona carona = new Carona(caronante, 13.2, 15.46, 13.45, 15.23, "15:05:00 10/10/2018");
		
		System.out.println("Adicionando primeiro caroneiro, retorno: " + carona.adicionarCaroneiro(caroneiro1));
		System.out.println("Adicionando segundo caroneiro, retorno: " + carona.adicionarCaroneiro(caroneiro2));
		System.out.println("Adicionando terceiro caroneiro, retorno: " + carona.adicionarCaroneiro(caroneiro3));
		System.out.println("Adicionando quarto caroneiro, retorno: " + carona.adicionarCaroneiro(caroneiro4));		
		
		System.out.println(carona);
		
		System.out.println("Fazendo os mesmos testes com CaronaAL");
		
		CaronaAL caronaAL = new CaronaAL(caronante, 13.2, 15.46, 13.45, 15.23, "15:05:00 10/10/2018", 3);
		
		System.out.println("Adicionando primeiro caroneiro, retorno: " + caronaAL.adicionarCaroneiro(caroneiro1));
		System.out.println("Adicionando segundo caroneiro, retorno: " + caronaAL.adicionarCaroneiro(caroneiro2));
		System.out.println("Adicionando terceiro caroneiro, retorno: " + caronaAL.adicionarCaroneiro(caroneiro3));
		System.out.println("Adicionando quarto caroneiro, retorno: " + caronaAL.adicionarCaroneiro(caroneiro4));		
		
		System.out.println(caronaAL);
		
	}

}
