package grupo;

import java.util.ArrayList;

import caroneiro.Caroneiro;
import usuario.Usuario;
import utilidades.HelperFormatacao;

public class Grupo {
	private int id;
	private String nome;
	private String descricao;
	static private int geradorId = 0;
	private final ArrayList<Usuario> membros;
	
	public Grupo(String nome, String descricao) {
		this.id = Grupo.geradorId++;
		this.nome = nome;
		this.descricao = descricao;
		membros = new ArrayList<Usuario>();
	}
	
	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getDescricao() {
		return descricao;
	}

	public void setDescricao(String descricao) {
		this.descricao = descricao;
	}

	public int getId() {
		return id;
	}

	public void adicionarMembro(Usuario usuario) {
		membros.add(usuario);
	}
	
	public String toStringMostraMembros(int numeroEspacos) {
		String espacos = HelperFormatacao.criaEspacos(numeroEspacos);
		
		StringBuilder stringBuilder = new StringBuilder();
		for(Usuario usuario: membros) {
			stringBuilder.append(usuario.toString(numeroEspacos + 1));
		}		
		
		String stringMembros = stringBuilder.toString();
		
		return toString(numeroEspacos) 
				+ String.format("%s| - Membros: \n%s",
					espacos, stringMembros);
	}
	
	public String toString(int numeroEspacos) {
		String espacos = HelperFormatacao.criaEspacos(numeroEspacos);

		
		return String.format("%s| Grupo\n"
				+ "%s| - Id: %d\n"
				+ "%s| - Nome: %s\n"
				+ "%s| - Descricao: %s\n",
				espacos,
				espacos, this.id,
				espacos, this.nome,
				espacos, this.descricao);
	}
	
	@Override
	public String toString() {
		return toString(0);
	}
	

}
